searchNodes=[{"doc":"Option library inspired by Rust.","ref":"ExOption.html","title":"ExOption","type":"module"},{"doc":"Returns none if the arg1 is none, otherwise returns arg2.Examplesiex&gt; ExOption.some(2) |&gt; ExOption.and_option(ExOption.none()) {:none} iex&gt; ExOption.none() |&gt; ExOption.and_option(ExOption.some(&quot;foo&quot;)) {:none} iex&gt; ExOption.some(2) |&gt; ExOption.and_option(ExOption.some(&quot;foo&quot;)) {:some, &quot;foo&quot;} iex&gt; ExOption.none() |&gt; ExOption.and_option(ExOption.none()) {:none}","ref":"ExOption.html#and_option/2","title":"ExOption.and_option/2","type":"function"},{"doc":"Returns none if the option is none, otherwise calls fun with the wrapped value and returns the result.Examplesiex&gt; ExOption.some(2) |&gt; ExOption.and_then(fn x -&gt; ExOption.some(x * x) end) |&gt; ExOption.and_then(fn x -&gt; ExOption.some(x * x) end) {:some, 16} iex&gt; ExOption.some(2) |&gt; ExOption.and_then(fn x -&gt; ExOption.some(x * x) end) |&gt; ExOption.and_then(fn _ -&gt; ExOption.none() end) {:none} iex&gt; ExOption.some(2) |&gt; ExOption.and_then(fn _ -&gt; ExOption.none() end) |&gt; ExOption.and_then(fn x -&gt; ExOption.some(x * x) end) {:none} iex&gt; ExOption.none() |&gt; ExOption.and_then(fn x -&gt; ExOption.some(x * x) end) |&gt; ExOption.and_then(fn x -&gt; ExOption.some(x * x) end) {:none}","ref":"ExOption.html#and_then/2","title":"ExOption.and_then/2","type":"function"},{"doc":"Returns none if the option is none, otherwise calls fun with the wrapped value and returns:some if fun returns true, andnone if fun returns false.Examplesiex&gt; ExOption.none() |&gt; ExOption.filter(fn n -&gt; rem(n, 2) == 0 end) {:none} iex&gt; ExOption.some(3) |&gt; ExOption.filter(fn n -&gt; rem(n, 2) == 0 end) {:none} iex&gt; ExOption.some(4) |&gt; ExOption.filter(fn n -&gt; rem(n, 2) == 0 end) {:some, 4}","ref":"ExOption.html#filter/2","title":"ExOption.filter/2","type":"function"},{"doc":"Converts from nested option to unnested option.Examplesiex&gt; ExOption.some(ExOption.some(6)) |&gt; ExOption.flatten() {:some, 6} iex&gt; ExOption.some(ExOption.none()) |&gt; ExOption.flatten() {:none} iex&gt; ExOption.none() |&gt; ExOption.flatten() {:none}","ref":"ExOption.html#flatten/1","title":"ExOption.flatten/1","type":"function"},{"doc":"Maps an option to another option by applying a function to a contained value.Examplesiex&gt; ExOption.some(&quot;Hello, World!&quot;) |&gt; ExOption.map(&amp;String.length/1) {:some, 13}","ref":"ExOption.html#map/2","title":"ExOption.map/2","type":"function"},{"doc":"Applies a function to the contained value (if any), or returns the provided default (if not).Examplesiex&gt; ExOption.some(&quot;foo&quot;) |&gt; ExOption.map_or(42, &amp;String.length/1) 3 iex&gt; ExOption.none() |&gt; ExOption.map_or(42, &amp;String.length/1) 42","ref":"ExOption.html#map_or/3","title":"ExOption.map_or/3","type":"function"},{"doc":"No value.","ref":"ExOption.html#none/0","title":"ExOption.none/0","type":"function"},{"doc":"Returns true if the option is a none value.Examplesiex&gt; ExOption.some(2) |&gt; ExOption.none?() false iex&gt; ExOption.none() |&gt; ExOption.none?() true","ref":"ExOption.html#none?/1","title":"ExOption.none?/1","type":"function"},{"doc":"Returns the arg1 if it contains a value, otherwise returns arg2.Examplesiex&gt; ExOption.some(2) |&gt; ExOption.or_option(ExOption.none()) {:some, 2} iex&gt; ExOption.none() |&gt; ExOption.or_option(ExOption.some(100)) {:some, 100} iex&gt; ExOption.some(2) |&gt; ExOption.or_option(ExOption.some(100)) {:some, 2} iex&gt; ExOption.none() |&gt; ExOption.or_option(ExOption.none()) {:none}","ref":"ExOption.html#or_option/2","title":"ExOption.or_option/2","type":"function"},{"doc":"Replaces the actual value in the option by the value given in parameter.Returning the old value if present, leaving a some in its place without deinitializing either one.Examplesiex&gt; ExOption.some(2) |&gt; ExOption.replace(5) {:some, 5} iex&gt; ExOption.none() |&gt; ExOption.replace(3) {:none}","ref":"ExOption.html#replace/2","title":"ExOption.replace/2","type":"function"},{"doc":"Some value.","ref":"ExOption.html#some/1","title":"ExOption.some/1","type":"function"},{"doc":"Returns true if the option is a some value.Examplesiex&gt; ExOption.some(2) |&gt; ExOption.some?() true iex&gt; ExOption.none() |&gt; ExOption.some?() false","ref":"ExOption.html#some?/1","title":"ExOption.some?/1","type":"function"},{"doc":"Returns the contained some value.Errors if the value equals none.Examplesiex&gt; ExOption.some(&quot;air&quot;) |&gt; ExOption.unwrap() &quot;air&quot; iex&gt; ExOption.none() |&gt; ExOption.unwrap() ** (ArgumentError) the value is none","ref":"ExOption.html#unwrap/1","title":"ExOption.unwrap/1","type":"function"},{"doc":"Returns the contained some value or a provided default.Examplesiex&gt; ExOption.some(&quot;car&quot;) |&gt; ExOption.unwrap_or(&quot;bike&quot;) &quot;car&quot; iex&gt; ExOption.none() |&gt; ExOption.unwrap_or(&quot;bike&quot;) &quot;bike&quot;","ref":"ExOption.html#unwrap_or/2","title":"ExOption.unwrap_or/2","type":"function"},{"doc":"Returns some if exactly one of arg1, arg2 is Some, otherwise returns none.Examplesiex&gt; ExOption.some(2) |&gt; ExOption.xor_option(ExOption.none()) {:some, 2} iex&gt; ExOption.none() |&gt; ExOption.xor_option(ExOption.some(2)) {:some, 2} iex&gt; ExOption.some(2) |&gt; ExOption.xor_option(ExOption.some(2)) {:none} iex&gt; ExOption.none() |&gt; ExOption.xor_option(ExOption.none()) {:none}","ref":"ExOption.html#xor_option/2","title":"ExOption.xor_option/2","type":"function"},{"doc":"Zips arg1 with arg2.Examplesiex&gt; ExOption.some(1) |&gt; ExOption.zip(ExOption.some(&quot;hi&quot;)) {:some, {1, &quot;hi&quot;}} iex&gt; ExOption.some(1) |&gt; ExOption.zip(ExOption.none()) {:none}","ref":"ExOption.html#zip/2","title":"ExOption.zip/2","type":"function"},{"doc":"","ref":"ExOption.html#t:option/0","title":"ExOption.option/0","type":"type"}]